package brs.visitor;
import brs.*;

import java.util.*;  // uses Comparable


/**
 * Counts all the nodes in the host tree.
 * @author DXN
 */
public class CountNodes implements IVisitor {
    public static final CountNodes Singleton = new CountNodes();
    private CountNodes() {
    }

    public Object emptyCase(BiTree host, Object nu) {
        return new Integer(0);
    }

    public Object nonEmptyCase(BiTree host, Object nu) {
        return addOne(add(host.getLeftSubTree().execute(this, null), 
                          host.getRightSubTree().execute(this, null)));
    }
    
    private Integer addOne(Object i) {
        return new Integer(1 + ((Integer)i).intValue());
    }
    
    private Integer add(Object i, Object j) {
        return new Integer(((Integer)i).intValue() + ((Integer)j).intValue());
    }
}